/*-----------------08-07-96 02:40pm-----------------
To allocate the memory of 256*256/4=16384 byte for a
 binary table to facilitate a file analysing for the
 internal coding table.
 Each couple of bit has the following value similar
 to logarithm of frequency for a cyrillic text:
 -1 - noncyrillic
  0 - indifferent
  1 - used
  2 - frequently used

६    ⠭  ࢮ  ⠭, 饣
 㪢  ன  ⠡ (345 ⠭)   
    (2: 97 ⠭)

 */
char  *most_frequently_next[53] =
{ "",
 /* \001 .                                                                                      */
"\061\001\002\003\004\005\007\010\012\013\014\015\016\020\021\022\023\026\030\031\040",
 /* \002                                                                                                                     */
"\001\006\011\017\024\034",
 /* \003 .                                                                                                              */
"\061\001\006\011\016\017\021\024\034",
 /* \004 .                                                                                                                */
"\061\001\006\011\017\021\024\034",
 /* \005 .                                                                                                                */
"\061\001\006\011\016\017\024\034",
 /* \006 .                                                                                              */
"\061\002\003\004\005\010\012\013\014\015\016\020\021\022\023\026\031",
 /* \007                                                                                                                             */
"\001\011",
 /* \010 .                                                                                                                */
"\061\001\005\006\011\016\024\034",
 /* \011 .                                                                                                */
"\061\003\004\005\010\012\013\014\015\016\021\022\023\030\031\040",
 /* \012 .                                                                                                                  */
"\061\005\011\014\016\023\034",
 /* \013 .                                                                                                          */
"\061\001\006\011\013\014\017\022\023\024\034",
 /* \014 .                                                                                              */
"\061\001\004\005\006\011\014\015\016\017\023\024\026\034\035\036\040",
 /* \015 .                                                                                                                  */
"\061\001\006\011\017\024\034",
 /* \016 .                                                                                              */
"\061\001\004\005\006\011\015\016\017\022\023\024\030\034\035\036\040",
 /* \017 .                                                                                              */
"\061\002\003\004\005\010\012\013\014\015\016\020\021\022\023\026\031",
 /* \020 .                                                                                                                */
"\061\001\006\011\017\023\024\034",
 /* \021 .                                                                                                  */
"\061\001\004\005\006\011\013\014\015\016\017\022\023\024\034",
 /* \022 .                                                                                                    */
"\061\001\006\011\013\014\016\017\022\023\024\034\035\040",
 /* \023 .                                                                                                    */
"\061\001\003\006\011\013\014\016\017\023\024\034\035\036",
 /* \024 .                                                                                              */
"\061\003\004\005\010\012\013\014\015\016\020\021\022\023\026\030\031",
"",
 /* \026 .                                                                                                                    */
"\061\001\011\017\023\024",
 /* \027                                                                                                                             */
"\001\011",
 /* \030                                                                                                                       */
"\001\006\011\024\034",
 /* \031 .                                                                                                                */
"\061\001\006\011\013\014\023\034",
"", "",
 /* \034 .                                                                                                        */
"\061\004\005\013\014\015\016\020\021\022\023\031",
 /* \035 .                                                                                                                              */
"\061",
 /* \036                                                                                                                     */
"\005\013\014\015\016\023",
"",
 /* \040 .                                                                                                                        */
"\061\003\016\022",
"", "", "", "", "", "", "", "",
"", "", "", "", "", "", "", "",
 /* \061 . . . . . . . . . . . . . . . . . . . . . . . .                                                         */
"\001\002\003\004\005\006\010\011\012\013\014\015\016\017\020\021\022\023\024\026\030\031\036\040",
"", "", ""
};

/*

   (1: 248 ⠭)
*/
char  *less_frequently_next[53] =
{ "",
 /* \001                                        */
"\006\011\042\024\025\027\037\041",
 /* \002 .                                           */
"\061\014\021\036\040\041",
 /* \003                                          */
"\013\014\022\023\026\036\041",
 /* \004                                        */
"\005\014\016\023\033\035\036\041",
 /* \005 i                         */
"\045\003\004\005\007\010\014\042\021\022\026\035\036\040\041",
 /* \006                                              */
"\006\007\027\030\041",
 /* \007                                            */
"\006\016\024\027\034\041",
 /* \010                                        */
"\002\003\004\014\015\017\035\041",
 /* \011                                  */
"\001\002\006\007\011\017\020\025\026\027\041",
 /* \012                                          */
"\001\004\006\013\017\021\022",
 /* \013 i                                     */
"\045\003\016\042\021\027\033\036\041",
 /* \014 i                                       */
"\045\002\007\010\013\042\037\041",
 /* \015                                    */
"\002\005\013\014\016\042\021\022\036\041",
 /* \016 i                                         */
"\045\003\013\014\042\027\041",
 /* \017                                    */
"\001\006\007\011\017\027\030\032\040\041",
 /* \020                                                */
"\013\014\021\041",
 /* \021                                      */
"\003\007\042\025\026\030\031\036\041",
 /* \022 i                                     */
"\045\003\015\020\042\026\030\036\041",
 /* \023 i                                     */
"\045\005\015\042\021\022\033\040\041",
 /* \024                                      */
"\001\002\007\011\024\034\037\040",
 /* \025                                              */
"\001\006\011\017\023",
 /* \026                                          */
"\006\014\016\033\034\035\036",
 /* \027 . i                                            */
"\061\045\006\017\024",
 /* \030 .                                           */
"\061\013\016\017\023\036",
 /* \031                                                */
"\015\016\017\024",
 /* \032                                                      */
"\011",
 /* \033                                              */
"\001\011\024\034\040",
 /* \034                                        */
"\002\003\006\007\010\012\026\030",
 /* \035                                  */
"\001\011\013\014\016\017\022\023\024\034\041",
 /* \036 .                                   */
"\061\003\004\012\020\021\022\026\030\036",
 /* \037 .                                               */
"\061\014\016\023",
 /* \040                                      */
"\004\005\010\013\014\015\021\023\026",
 /* \041                                                  */
"\016\021\026",
 /* \042 .                                 */
"\061\001\005\010\013\014\015\016\021\022\023", "","",
 /* \045 i i i i i                                         */
"\001\013\016\022\024", "", "",
 /* \050 j                                                     */
"\001", "", "", "", "",
 /* \055 w                                                     */
"\001", "", "", "",
 /* \061 . . . . . . .                                   */
"\007\042\025\027\034\037\041", "", "", ""
};
/*
ᯮ짮 ⠭ (-1)
*/
char  *rarely_next[53] =
{  "", "",
 /* \002 j w                                                                                                                     */
"\050\055\012\025\031",
 /* \003 w                                                                                                                    */
"\055\002\012\025\047\056",
 /* \004 j                                                                                                          */
"\050\007\010\012\025\027\031\032\041\047\056",
 /* \005 j w                                                                                                                 */
"\050\055\012\025\032\047\056",
 /* \006 i                                                                                                                    */
"\045\034\035\044\047\056",
 /* \007 i j w                                                                                          */
"\045\050\055\010\012\015\020\025\026\031\032\033\037\040\041\044\047\056",
 /* \010 j w                                                                                                           */
"\050\055\012\025\027\031\032\041\044\047",
 /* \011                                                                                                                             */
"\033\035",
 /* \012 j w                                                                                             */
"\050\055\053\052\057\051\042\043\032\033\035\036\041\044\047\056\054",
 /* \013 w                                                                                                              */
"\055\002\012\025\032\040\044\047\056", "",
 /* \015 j w                                                                                                             */
"\050\055\010\012\032\033\041\044\047", "",
 /* \017 w                                                                                                                            */
"\055\033",
 /* \020 j w                                                                                                         */
"\050\055\003\007\010\012\025\037\047\056\054",
 /* \021                                                                                                                             */
"\047\056",
 /* \022                                                                                                                           */
"\012\047\056",
 /* \023 w                                                                                                                    */
"\055\007\010\012\032\047",
 /* \024 i                                                                                                                      */
"\045\033\041\047\056",
 /* \025 j w                                                                               */
"\050\055\002\003\004\005\007\010\012\013\020\026\027\030\031\032\033\035\037\040\041\044\047\056",
 /* \026 s                                                                                                              */
"\046\007\012\025\032\037\041\044\047",
 /* \027 j s w                                                                                            */
"\050\046\055\002\007\010\016\020\025\027\030\031\032\033\044\047\056",
 /* \030 j w                                                                                               */
"\050\055\002\004\005\007\010\012\020\025\026\032\040\044\047\056",
 /* \031 w                                                                                                      */
"\055\007\010\012\025\027\032\037\040\041\044\047\056",
 /* \032 s w                                                               */
"\046\055\002\003\004\005\007\010\012\013\014\015\020\064\053\052\057\051\042\043\021\022\025\026\027\030\031\033\044\047\056\054",
 /* \033 i j s w                                                                           */
"\045\050\046\055\012\013\020\064\053\052\057\051\042\043\022\025\027\030\031\033\035\044\047\056\054",
 /* \034 i j s w                                                                                       */
"\045\050\046\055\017\053\052\057\051\042\043\033\035\036\041\044\047\056\054",
 /* \035 j s                                                                                                   */
"\050\046\053\052\057\051\042\043\033\035\044\047\056\054",
 /* \036 j s                                                                                           */
"\050\046\064\053\052\057\051\042\043\033\034\035\037\041\044\047\056\054",
 /* \037 i j s w                                                                                     */
"\045\050\046\055\003\020\053\052\057\051\042\043\025\033\034\036\040\047\056\054",
 /* \040 i j s w                                                                                     */
"\045\050\046\055\011\017\053\052\057\051\042\043\024\025\033\036\041\047\056\054",
 /* \041 i j s w                                                                           */
"\045\050\046\055\006\011\064\053\052\057\051\042\043\024\032\033\034\035\036\040\041\044\047\056\054",
 /* \042 i j s w ա բ գ դ զ է թ ժ ի լ խ կ հ ս վ                        */
"\045\050\046\055\002\003\004\005\007\010\012\013\014\015\016\020\064\053\052\057\051\042\043\021\022\023\025\026\027\030\031\032\033\034\035\036\037\040\041\044\047\056\054",
 /* \043 i w ְ                                                                                                */
"\045\055\064\042\032\033\034\035\036\037\040\041\044\047\056",
 /* \044                                                                                                         */
"\064\053\052\057\051\042\043\033\034\035\041\054",
 /* \045 i i i i i i i i i i i                                                                                                */
"\053\052\057\051\042\043\033\034\035\041\054",
 /* \046 s s s s s s s s s s                                                                                                   */
"\012\042\032\033\034\035\036\037\040\041",
 /* \047                                                                                                         */
"\064\053\052\057\051\042\043\033\034\035\041\054",
 /* \050 jw j j j j j j j j j j j j j j j j                                                                              */
"\055\002\012\020\025\027\032\033\034\035\036\037\040\041\044\047\056",
 /* \051 Ӱ i w                                                                                                  */
"\064\045\055\032\033\034\035\036\037\040\041\044\047\056",
 /* \052  i w                                                                                                  */
"\064\045\055\032\033\034\035\036\037\040\041\044\047\056",
 /* \053  i j w                                                                             */
"\064\045\050\055\002\004\005\007\010\012\020\025\026\032\033\034\035\036\037\040\041\044\047\056",
 /* \054 i w                                                                                                 */
"\045\055\064\042\032\033\034\035\036\037\040\041\044\047\056",
 /* \055 wj w w w w w w w w w w w w w w w                                                                                 */
"\050\027\033\034\037\040\053\052\057\051\042\043\033\035\041\054",
 /* \056                                                                                                           */
"\064\053\052\057\051\042\043\033\035\041\054",
 /* \057 i j s w ơ Ƣ ƣ Ƥ Ʀ Ƨ Ʃ ƪ ƫ Ƭ ƭ Ư ư ƽ ƾ                        */
"\045\050\046\055\002\003\004\005\007\010\012\013\014\015\016\020\064\053\052\057\051\042\043\021\022\023\025\026\027\030\031\032\033\034\035\036\037\040\041\044\047\056\054",
 /* \060 -  (ࠡ뢠 ⤥쭮)                                                                                                                          */
"",
 /* \061 . .                                                                                                                           */
"\033\035",
 /* \062 . .                                                                                                                           */
"\033\035",
 /* \063 . .                                                                                                                           */
"\033\035",
 /* \064 s                                                                                                      */
"\046\053\052\057\051\042\043\033\035\037\044\047\054",
};
/*
char oneright[]="\251\262\370\372\374\255";
char oneleft[]="\253\265\370\372\374\240";
char lightright[]="\220\226\203\232\222\230\231\237";
char lightleft[]="\221\233\227\222\223\230\231\237";
char twoleft[]="\245\252\263\266\371\373\234\236\207\224\202\204\205";
char tworight[]="\242\250\257\266\371\373\235\211\224\200\202\204\205";
char vertleft[]="\237\362\226\211\221\225\212\213\243\246\215";
char vertright[]="\363\365\227\207\221\225\212\213\243\246\215";
*/
char oneright[]={0x96, 0x9A, 0xA9, 0xF2, 0xF8, 0xFA, 0xFC, 0x83, 0xAD, 0x92, 0x98, 0x99, 0x9F, 0x00};
char oneleft[]= {0x97, 0x9B, 0xAB, 0xF5, 0xF8, 0xFA, 0xFC, 0xA0, 0x92, 0x93, 0x98, 0x99, 0x9F, 0x00};
char twoleft[]=  {0xA5, 0xAA, 0xF3, 0xF6, 0xF9, 0xFB, 0x9C, 0x9E, 0x87, 0x94, 0x82, 0x84, 0x85, 0x00};
char tworight[]= {0xA2, 0xA8, 0xAF, 0xF6, 0xF9, 0xFB, 0x9D, 0x89, 0x94, 0x80, 0x82, 0x84, 0x85, 0x00};
char vertleft[]= {0xA3, 0xA6, 0xAF, 0xF2, 0x96, 0x89, 0x91, 0x95, 0x8A, 0x00};
char vertright[]={0xA3, 0xA5, 0xF3, 0xF5, 0x97, 0x87, 0x91, 0x95, 0x8B, 0x00};
/*
⠭ 筮 㪢 ᫥     ,  
⠭ ᮮ⢥  㪢.   㪢 
     2  1. 筠 ᫥   
(-1)

--------------------------------------------------*/
char* algorithm[16385];

/*         ਧ TO_CAPITAL
 ( ਫ᪨ 㪢 =5, 宦     < 128 =1
                        =6, 宦     < 128 =2
                   ࠧ =7, 稥   < 128 =3) */
/*
	 TO_CAPITAL code:

                           | Char code < 128 |  Char code > 128
	  -----------------------+-----------------+-------------------
	  Capital like cyrillic  |       1         |       5
	  Small   like cyrillic  |       2         |       6
	  Other                  |       3         |       7
					                  */
char TO_CAPITAL [256]={
 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
 3, 1, 1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1, 1,
/* for some Caucasian languages "I" is not alwys capital */
 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 1, 3, 3, 3, 3, 3,
/* for some cyrillic languages probably "Y" may be used for a small letter */
 3, 3, 2, 2, 2, 2, 2, 2, 3, 2, 2, 2, 2, 2, 2, 2,
/* for some cyrillic languages prefix "a" usually appears before capitalized */
/* word, for others "h" probably  may be used as capital */
 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3,
 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7,
 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7,
 7, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 7, 5, 5,
 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5,
 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5,
 7, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6,
 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6,
 7, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 7, 6, 6};

/*           ਧ TO_LETTER:
 1-32 - 㪢 ᪮ 䠢 -  宦  ⠭,
33-47 - \"e  㣨 㪢  ISO 8859-5  ⠪ ⨭᪨ 㪢, 宦    ⠭,
   45 - 稥 ⨭᪨ 㪢, 騥  ᫮ ਫ᪨ 몮
   48 - ⠫ ⨭᪨ 㪢,  騥  ᫮ ਫ᪨ 몮
   49 - ஡   ९,
   50 - । ਬ몠騥  ᫮   騥  ⥪
           128,
   51 - ।  ⥪ ᨬ   128,
   52 - 稥 ਫ᪨  ࠢ騥 ᨬ ( 㬥஢)
*/

/*       TO_LETTER code:

	   Chars                 |      Codes
	-------------------------+----------------------
  Russian letters A-YA     |     1 - 32
	and similar latin letters|
	-------------------------+----------------------
	 \"E and other cyrillic  |    33 - 44,46,47
	letters ISO 8859-5       |
	and similar latin letters|
	-------------------------+----------------------
  Latin letters  usual     |       45     (w)
	for some cyrillic        |
	languages                |
	-------------------------+----------------------
  The other latin letters  |       48     (Z)
	-------------------------+----------------------
  The space and  another   |       49     (.)
  word delimiters          |
	-------------------------+----------------------
	Digits and symbols not   |       50
	adjacent to words        |
	-------------------------+----------------------
	Unusual for text chars   |       51
	with codes < 128         |
	-------------------------+----------------------
	Non-documented cyrillic  |       52
  and control chars        |
*/

unsigned char TO_LETTER[256]={
51, 51, 51, 51, 51, 51, 51, 51, 49, 51, 49, 51, 49, 49, 51, 51,
51, 51, 51, 51, 51, 50, 51, 51, 51, 51, 51, 51, 51, 51, 51, 51,
49, 49, 49, 50, 50, 50, 50, 49, 49, 49, 50, 50, 49, 49, 49, 50,
50, 50, 50, 50, 50, 50, 50, 50, 50, 50, 49, 49, 49, 50, 49, 49,
50,  1,  3, 18, 48,  6, 45, 48, 14, 38, 48, 11, 48, 13, 48, 15,
/*   A   B   C   D   E   F   G   H   I   J   K   L   M   N   O
 P   Q   R   S   T   U   V   W   X   Y   Z    */
17, 45, 48, 37, 19, 48, 48, 45, 22, 45, 48, 49, 49, 49, 49, 49,
49,  1, 48, 18, 48,  6, 48, 48, 45, 38, 48, 45, 48, 19, 16, 15,
/*'  a   b   c   d   e   f   g   h   i   g   k   l   m   n   o
 p   q   r   s   t   u   v   w   x   y   z    */
17, 45, 48, 37, 48,  9, 48, 45, 22, 20, 48, 49, 49, 49, 49, 49,
52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52,
52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52,
49, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 49, 46, 47,
 1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16,
17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32,
 1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16,
17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32,
49, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 49, 46, 47
};





